# -*- coding: utf-8 -*-
import functools
import sys
import re

# кортеж тестируемых выражений языка ('' - разделитель группы):
prgs = '', \
       '10 / 3', '10 / 3.', '10 / float( 3 )', \
       '', \
       'type( "строка UTF-8" )', 'len( "строка UTF-8" )', \
       '', \
       'type( range( 5 ) )', 'range( 5 )', 'list( range( 5 ) )', \
       'type( xrange( 5 ) )', 'map( int, [ "1", "2", "3" ] )', \
       'list( map( int, [ "1", "2", "3" ] ) )', \
       '', \
       'reduce( lambda x, y: x + y, range( 5 ) )', \

def arg_exit( arg, cod=1 ):
    print( 'недопустимый параметр командной строки: {} !'.format( arg ) )
    sys.exit( cod )

def dialist( ls ):                    # разбор диапазонов  
    lim = re.split( '\D+', ls )
    print( lim )
    if len( lim ) != 2: arg_exit( ls, 2 )
    try:
        ilim = list( map( int, lim ) )
    except ValueError: arg_exit( ls, 3 )
    print( '===', ilim )
    args = list( range( min( ilim ), max( ilim ) + 1 ) )
    return args

def arglist( la ):
    lb = []
    for x in la:                      # разнос параметров через ,
         lb += re.split( ',', x )
    args = []
    for x in lb:                      # разбор параметров  
        try:
            args.append( int( x ) ) 
        except ValueError:
            args += dialist( x ) 
    return args


print( 'версия Python {}.{}.{} на платформе {}'. \
       format( sys.version_info.major, sys.version_info.minor, sys.version_info.micro, sys.platform ) ) 
if len( sys.argv ) == 1: # запуск без параметров
    r = functools.reduce( lambda x, y: x + y, map( lambda x: int( len( x ) == 0 ), prgs ) )
    args = list( range( r + 1 ) )
else:                    # обработка списка параметров
    args = arglist( sys.argv[ 1: ] ) 
sarg = set( args )       # удаление дубликатов (можно и не делать)

n = 0
for x in prgs:
    if len( x ) == 0:
        n += 1
        if n not in args: continue
        print( '{:02d}: -------------------------------------'.format( n ) )
    else:
        if n not in args: continue
        try:
            print( '{} = {}'.format( x, eval( x ) ) )
        except ( NameError, SyntaxError ) as err:
            print( '{} => {} !'.format( x, err ) )
        except:   
            print( '{} => непонятное исключение !'.format( x ) )


# операция / над целыми понимается как целочисленная в Python 2.7.3, как вещественная в Python 3.2.3
# для UTF-8 строки len() - это число число: Python 2.7.3 - байт, Python 3.2.3 - символов 
# вызовы range(), map() в Python 3.2.3 возвращают не [...], а специальные типы
# часть функциональных вызовов (reduce) отнесены в модуль functools
