#!/usr/bin/python3 -O
# -*- coding: utf-8 -*-

from multiprocessing import Process, Queue, Pipe, Value, Array
import os
import queue

def fq( qp, qc ):
    while True:
        try:
            s = qp.get( block=False )
        except queue.Empty:
            break
        print( os.getpid(), ' : ', s )
    qc.put( [  None, 'привет от потомка', os.getpid(), [ i for i in range( 10 ) ] ] )

if __name__ == '__main__':
    print( '=== Queue ===' )
    qp = Queue(); 
    qc = Queue(); 
    p = Process( target=fq, args=( qp, qc ) )
    p.start()
    qp.put( 'привет №1 от родителя' )
    qp.put( 'привет №2 от родителя' )
    print( os.getpid(), ' : ', qc.get( timeout=3 ) ) 
    p.join()

#------------------------------------------------
def fp( conn ):
    while True:
       if not conn.poll( 0.3 ): break
       print( os.getpid(), ' : ', conn.recv() )
    conn.send( [  None, 'привет от потомка', os.getpid(), [ i for i in range( 10 ) ] ] )
    conn.close()

if __name__ == '__main__':
    print( '=== Pipe ===' )
    pp, pc = Pipe()
    p = Process( target=fp, args=( pc, ) )
    p.start()
    pp.send( 'привет №1 от родителя' )
    pp.send( 'привет №2 от родителя' )
    print( os.getpid(), ' : ', pp.recv() ) 
    p.join()

#------------------------------------------------
def fs( n, a, s ):
    print( os.getpid(), ' : ', s[:], ' + ', n.value, ' + ' , a[:] )
    n.value = 3.14159
    z = -1;
    for i in range( len( a ) ):
        z *= -1
        a[ i ] = z * a[ i ] * a[ i ]
    s[:] = 'возврат из потомка'

if __name__ == '__main__':
    print( '=== shared memory ===' )
    num = Value( 'd', 123.456 )
    arr = Array( 'i', range( 10 ) )
    str = Array( 'u', 'привет от родителя' )
    p = Process( target=fs, args=( num, arr, str ) )
    p.start()
    p.join()
    print( os.getpid(), ' : ', str[:], ' + ', num.value, ' + ' , arr[:] )
