#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import time
import sys
import getopt

delay = 1
procnum = 2
debuglevel = 0

opts, args = getopt.getopt( sys.argv[1:], "p:d:v" )
for opt, arg in opts:     # опции (ключи) командной строки (-v, -t, -d, -a)
    if opt[ 1: ] == 'v' : debuglevel = debuglevel + 1
    if opt[ 1: ] == 't' : threadnum = int( arg )
    if opt[ 1: ] == 'd' : delay = int( arg )
    if opt[ 1: ] == 'a' : active = 1

childs = []
if debuglevel :
     print( 'родительский процесс {}'.format( os.getpid() ) )
for i in range( 0, procnum ) :
    tim = time.time();
    try :
        pid = os.fork();
    except :
        print( 'error: create child process' ); sys.exit( 33 )
    if pid == 0 :
        trun = time.time() - tim;
        if debuglevel :
           print( 'дочерний процесс {} - задержка на запуск: {:14.11f}'. \
                  format( os.getpid(), trun ) )
        time.sleep( delay )
        trun = time.time() - tim;
        if debuglevel :
           print( 'дочерний процесс {} - время завершения: {:14.11f}'. \
                  format( os.getpid(), trun ) )
        sys.exit( 3 )
    if pid > 0 :
        childs.append( pid )
        if debuglevel : 
            print( '{}: создан новый дочерний процесс {}'.format( os.getpid(), pid ) )
print( 'ожидание завершения дочерних процессов ...' )
for p in childs :
    pid, status = os.wait()
    if debuglevel :
        print( 'код завершения процесса {} = {}'.format( pid, os.WEXITSTATUS( status ) ) )
print( 'все порождённые процессы успешно завершены' )

